module Livermore
  class CFOrder
    def initialize(order)
      @order = order
    end

    def as_json
      {
        market: @order.market,
        operation_type: @order.operation,
        order_type: @order.type,
        size: @order.amount,
        price: round(@order.price)
      }
    end

    private

    def round(price)
      case @order.type
      when Order::ASK then price.ceil 5
      when Order::BID then price.floor 5
      end
    end
  end
end
