module Livermore
  class Order
    ASK = :sell
    BID = :buy
    LIMIT_ORDER = :limit_order

    attr_reader :market, :id, :price, :amount, :amount_filled, :status, :type, :operation, :created_at

    def initialize(market:, id: nil, price:, amount: 0, type:, operation: nil)
      @market = market
      @id = id
      @price = price
      @amount = amount
      @type = type
      @operation = operation
    end

    def operation
      @operation || LIMIT_ORDER
    end

    def to_s
      format '{ price: %.7f, amount: %.7f }', price, amount
    end

    def colorize
      case type
      when ASK then to_s.red
      when BID then to_s.green
      end
    end
  end
end
